SystemOrganization addCategory: #'IRDA2013-sorting2-Tests'!

TestCase subclass: #S2BubbleSortTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2BubbleSortTests methodsFor: 'as yet unclassified' stamp: 'db 5/13/2013 17:58:33.486'!
testStepwiseSorting
	| list sorter newList |
	"list to sort"
	list := #(3 2 4 1) asOrderedCollection.
	"initializing bubble sorter"
	sorter := S2BubbleSorter new.
	sorter model: list.
	
	self assert: sorter isSorted not.	
		
	newList := sorter nextStep.
	self assert: newList equals: #(2 3 4 1) asOrderedCollection.
	self assert: sorter isSorted not.	
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 3 4 1) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 3 1 4) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 3 1 4) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 1 3 4) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 1 3 4) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(1 2 3 4) asOrderedCollection.
	self assert: sorter isSorted.
	
! !

TestCase subclass: #S2BubblesorterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2BubblesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 00:38:31.1'!
testSort
|sorter sortedList|
	sorter := S2Bubblesorter new.
	sorter setupList: #(2 5 8 2 6 4 8 2) asOrderedCollection.
	sortedList := #(2 2 2 4 5 6 8 8) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

TestCase subclass: #S2ListTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:57:59.3'!
testAddElementAsSorted
	| expected list |
	list := S2List new.
	list sortedIndices: #(3 2) asSortedCollection.
	expected := #(4 3 2) asSortedCollection.
	list addIndexAsSorted: 4.
	self assert: (list sortedIndices) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 18:30:22.982'!
testInsertPivotAt1
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 7.
	expected := #(3 7 1 2 0 8 0 2) asOrderedCollection.
	list insertPivotAt: 3.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 18:21:25.101'!
testInsertPivotAt2
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 8.
	expected := #(2 3 7 2 0 8 0 1) asOrderedCollection.
	list insertPivotAt: 1.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 18:28:50.913'!
testInsertPivotAt3
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 4.
	expected := #(3 7 2 8 0 0 1 2) asOrderedCollection.
	list insertPivotAt: 7.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 19:25:35.429'!
testInsertPivotAt4
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 4.
	expected := #(3 7 2 0 8 0 1 2) asOrderedCollection.
	list insertPivotAt: 4.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:52:43.334'!
testSwitchElments
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	expected := #(3 7 8 0 2 0 1 2) asOrderedCollection.
	list switchElementAt: 3 withElementAt: 5.
	self assert: (list elements) equals: expected.! !

TestCase subclass: #S2QuicksortFocusedIndicesEvaluatorTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksortFocusedIndicesEvaluatorTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 17:12:34.167'!
testCompareElements1
|evaluator|
	evaluator := S2QuicksortFocusedIndicesEvaluator new.
	self assert: (evaluator compareElement: 4 withElement: 2 withPivot: 3)
	! !

!S2QuicksortFocusedIndicesEvaluatorTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 17:12:52.79'!
testCompareElements2
|evaluator|
	evaluator := S2QuicksortFocusedIndicesEvaluator new.
	self assert: (evaluator compareElement: 1 withElement: 2 withPivot: 3) not
	! !

!S2QuicksortFocusedIndicesEvaluatorTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 17:13:12.593'!
testCompareElements3
|evaluator|
	evaluator := S2QuicksortFocusedIndicesEvaluator new.
	self assert: (evaluator compareElement: 4 withElement: 5 withPivot: 3) not
	! !

TestCase subclass: #S2QuicksortFocusedIndicesFinderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksortFocusedIndicesFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 20:22:59.579'!
testInitializeFocusedIndices
|finder list|
	finder := S2QuicksortFocusedIndicesFinder new.	
	list := S2List new.
	list setupList: #(3 1 6 4 7 2) asOrderedCollection.
	list leftBoundIndex: 1.
	list rightBoundIndex: 6.
	finder initializeFocusedIndicesInList: list.
	self assert: list firstFocusedIndex equals: 1.
	self assert: list secondFocusedIndex equals: 5.
	self assert: list pivotIndex equals: 6.! !

!S2QuicksortFocusedIndicesFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 20:36:27.718'!
testNextFocus1
| finder list |
	list := S2List new.
	list setupList: #(2 5 0 3 4 1 6 3).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 7.
	list pivotIndex: 8.
	finder := S2QuicksortFocusedIndicesFinder new.
	finder nextFocusedElementsIndicesInList: list.
	self assert: (list firstFocusedIndex) equals: 2.
	self assert: (list secondFocusedIndex) equals: 7.
	self assert: (list pivotIndex) equals: 8.
	! !

!S2QuicksortFocusedIndicesFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 20:36:49.108'!
testNextFocus2
| finder list |
	list := S2List new.
	list setupList: #(2 5 0 3 4 1 6 3).
	list firstFocusedIndex: 2.
	list secondFocusedIndex: 7.
	list pivotIndex: 8.
	finder := S2QuicksortFocusedIndicesFinder new.
	finder nextFocusedElementsIndicesInList: list.
	self assert: (list firstFocusedIndex) equals: 2.
	self assert: (list secondFocusedIndex) equals: 6.
	self assert: (list pivotIndex) equals: 8.
	! !

TestCase subclass: #S2QuicksortListPartFinderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:03:06.365'!
testFindLeftIndex1
	|finder right|
	finder := S2QuicksortListPartFinder new.
	right := finder findLeftIndexInListWithLength: 5 
		withSortedIndices: #(3).
	self assert: right equals: 1.! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:03:47.957'!
testFindLeftIndex2
	|finder right|
	finder := S2QuicksortListPartFinder new.
	right := finder findLeftIndexInListWithLength: 5 
		withSortedIndices: #(1 2 3 4 5).
	self assert: right equals: nil.! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:03:40.36'!
testFindLeftIndex3
	|finder right|
	finder := S2QuicksortListPartFinder new.
	right := finder findLeftIndexInListWithLength: 5 
		withSortedIndices: #(2 3 4 5).
	self assert: right equals: 1.! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:04:02.439'!
testFindLeftIndex4
	|finder right|
	finder := S2QuicksortListPartFinder new.
	right := finder findLeftIndexInListWithLength: 5 
		withSortedIndices: #(1 2 4 5).
	self assert: right equals: 3.! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:51:41.563'!
testFindRightIndex1
	|finder right|
	finder := S2QuicksortListPartFinder new.
	right := finder findRightIndexInListWithLength: 5 
		withSortedIndices: #(3).
	self assert: right equals: 2! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:51:45.703'!
testFindRightIndex2
	|finder right|
	finder := S2QuicksortListPartFinder new.
	right := finder findRightIndexInListWithLength: 5 
		withSortedIndices: #(1 2 3 4 5).
	self assert: right equals: nil! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:51:50.124'!
testFindRightIndex3
	|finder right|
	finder := S2QuicksortListPartFinder new.
	right := finder findRightIndexInListWithLength: 5 
		withSortedIndices: #(1 2 3 4).
	self assert: right equals: 5! !

TestCase subclass: #S2QuicksortListPartSorterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksortListPartSorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 17:46:53.236'!
testUpdatePivotPosition
	| list partSorter |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list firstFocusedIndex: 3.
	list pivotIndex: 5.
	partSorter := S2QuicksortListPartSorter new.
	partSorter updatePivotPositionInList: list.
	self assert: (list elements) equals: #(2 8 2 4 6) asOrderedCollection.! !

TestCase subclass: #S2QuicksorterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 14:57:44.895'!
testSort
|sorter sortedList|
	sorter := S2Quicksorter new.
	sorter setupList: #(2 5 8 2 6 4 8 2) asOrderedCollection.
	sortedList := #(2 2 2 4 5 6 8 8) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !
